Bug 171715 - nfsd: clear signals before exiting the nfsd() thread
nfsd: clear signals before exiting the nfsd() thread
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Steve Dickson
Brian Brock
:
Depends On:
Blocks: 168429
  Show dependency treegraph
 
Reported: 2005-10-25 11:38 EDT by Steve Dickson
Modified: 2007-11-30 17:07 EST (History)
1 user (show)

See Also:
Fixed In Version: RHSA-2006-0132
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-03-07 15:33:11 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Proposed RHEL4 Patch (343 bytes, patch)
2005-10-25 11:41 EDT, Steve Dickson
no flags Details | Diff

  None (edit)
Description Steve Dickson 2005-10-25 11:38:29 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.3) Gecko/20041020

Description of problem:
tree f657d0dcc3f3d495fbe359cee2ea35868c10b128
parent d13df84ff7f3f3e26a9643c1d3cbf94cef9b5b59
author NeilBrown <neilb@cse.unsw.edu.au> Sun, 17 Apr 2005 05:26:37 -0700
committer Linus Torvalds <torvalds@ppc970.osdl.org> Sun, 17 Apr 2005 05:26:37 -0700

[PATCH] nfsd: clear signals before exiting the nfsd() thread

Fixes the error "RPC: failed to contact portmap (errno -512)." when the server
later tries to unregister from the portmapper.

Signed-off-by: Trond Myklebust <Trond.Myklebust@netapp.com>
Signed-off-by: J. Bruce Fields <bfields@citi.umich.edu>
Signed-off-by: Neil Brown <neilb@cse.unsw.edu.au>
Signed-off-by: Andrew Morton <akpm@osdl.org>
Signed-off-by: Linus Torvalds <torvalds@osdl.org>

 nfsd/nfssvc.c |    2 ++
 1 files changed, 2 insertions(+)

Index: fs/nfsd/nfssvc.c
===================================================================
--- 9531a56973381aa48a10fbc7073d1109f380d550/fs/nfsd/nfssvc.c  (mode:100644 sha1:39551657e65659d6d25197beffd952c3715a879d)
+++ f657d0dcc3f3d495fbe359cee2ea35868c10b128/fs/nfsd/nfssvc.c  (mode:100644 sha1:02ded7cfbdcf1261d39c13ab0f01d27a79cc93fd)
@@ -258,6 +258,8 @@
 				break;
 		err = signo;
 	}
+	/* Clear signals before calling lockd_down() and svc_exit_thread() */
+	flush_signals(current);
 
 	lock_kernel();
 
-
To unsubscribe from this list: send the line "unsubscribe bk-commits-head" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1.bring a RHEL4 system down
2.
3.
  

Additional info:
Comment 1 Steve Dickson 2005-10-25 11:41:12 EDT
Created attachment 120370 [details]
Proposed RHEL4 Patch

-------- Original Message --------
Subject: [RHEL4 Patch] nfsd: clear signals before exiting the nfsd() thread
Date: Mon, 25 Apr 2005 11:50:25 -0400
From: Steve Dickson <SteveD@redhat.com>
Reply-To: rhkernel-list@redhat.com
Organization: Red Hat Inc. Internal News
Newsgroups: rhat.general.rhkernel-list

Here is an upstream patch that was just committed which
causes nfsd to clear it's signal mask before
unregistering with the portmapper. Not doing this
cause the "RPC: failed to contact portmap (errno -512)"
message to be logged when a system is being brought
down.

I've seen this message number of times, but when it
came time to explicitly test this patch I was not able
consistently reproduce the problem. Although I have
not see this problem with the -mm kernel, which does
have this patch....


steved.
Comment 6 Red Hat Bugzilla 2006-03-07 15:33:12 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0132.html

Note You need to log in before you can comment on or make changes to this bug.